#ifndef DEFINE_H
#define DEFINE_H

#define SWITCH_BANK1 INSCON |= 0x40
#define SWITCH_BANK0 INSCON &= 0xbf

#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE 1
#endif

typedef unsigned char uchar;
typedef unsigned char U8;
typedef unsigned char u8;
typedef unsigned char uint8;
typedef unsigned char xdata uint8x;

typedef unsigned int U16;
typedef unsigned int uint16;
typedef unsigned int uint;

typedef unsigned long U32;
typedef unsigned long uint32;

typedef signed char S8;
typedef signed char int8;

typedef signed int S16;
typedef signed int int16;

typedef signed long S32;
typedef signed long int32;

typedef union
{
	uint32 lword;
	uint16 word[2];
	uint8 byte[4];
} Word32;

typedef bit BOOL;

#define BIT0 0x01
#define BIT1 0x02
#define BIT2 0x04
#define BIT3 0x08
#define BIT4 0x10
#define BIT5 0x20
#define BIT6 0x40
#define BIT7 0x80

// #ifdef __MAIN__
// const uint8 code BIT8MAP[]=
//{
//     BIT0,BIT1,BIT2,BIT3,BIT4,BIT5,BIT6,BIT7
// };

// const uint32 code BIT32MAP[]=
//{
//     EBIT0,EBIT1,EBIT2,EBIT3,EBIT4,EBIT5,EBIT6,EBIT7,
//     EBIT8,EBIT9,EBIT10,EBIT11,EBIT12,EBIT13,EBIT14,EBIT15,
//     EBIT16,EBIT17,EBIT18,EBIT19,EBIT20,EBIT21,EBIT22,EBIT23,
//     EBIT24,EBIT25,EBIT26,EBIT27,EBIT28,EBIT29,EBIT30,EBIT31,
// };
// #else
// extern const uint8 code  BIT8MAP[];
////extern const uint32 code BIT32MAP[];
// #endif

#define nop() _nop_()

#endif