#ifndef __KEY_H__
#define __KEY_H__

#ifndef KEYEXT
#define KEYEXT extern
#endif

#define KeyNums 1

enum
{
    SetKey,
};

enum
{
    KeyRls = 0,
    KeyDw,
    KeyDWLong,
};

typedef struct
{
    uint8 Status;    // 按键状态，按下，释放
    uint8 TmStu;     // 定时器状态
    uint16 DlyCnt;   // 延时计数
    uint16 KeyThd;   // 按键门限值
    uint16 LgKeyThd; // 长按键门限值
} KEYCTR;

KEYEXT KEYCTR idata gs_KeyCtr[KeyNums];

void KeyInit(void);
void LongKeyProc(uint8 keyNum);
void KeyProc(void);
void KeyScan(void);
// void CoverKeyScan(void);

#endif
