#include "Include.h"

void EINT0_INT(void) interrupt 0
{
}

void T0_INT(void) interrupt 1
{
    guc_TimeEvent |= flgEtTim_2ms;
    Uart_Dy10ms();
    ComBom_10msDy();
}

void EINT1_INT(void) interrupt 2
{
}

void T1_INT(void) interrupt 3
{
}

void UART0_INT(void) interrupt 4
{
    if (S0CON & 0x01)
    {
        S0CON &= ~0x01;
#if (UART == UART0)
        Uart_Receive();
#endif
    }
    if (S0CON & 0x02)
    {
        S0CON &= ~0x02;
#if (UART == UART0)
        Uart_Transmit();
#endif
    }
}

void UART1_INT(void) interrupt 5
{
    if (S1CON & 0x01)
    {
        S1CON &= ~0x01;
#if (UART == UART1)
        Uart_Receive();
#endif
    }
    if (S1CON & 0x02)
    {
        S1CON &= ~0x02;
#if (UART == UART1)
        Uart_Transmit();
#endif
    }
}

void T2OVF_INT(void) interrupt 6
{
}

void T2CAP_INT(void) interrupt 7
{
}

void ADC_EOC_INT(void) interrupt 8
{
}

void ADC_REF_INT(void) interrupt 9
{
}

void CLKERR_INT(void) interrupt 10
{
}

void CPL_INT(void) interrupt 11
{
}

void EINT2_INT(void) interrupt 12
{
    //  IEN2 &= ~BIT0;
}

void EINT3_INT(void) interrupt 13
{
    //  IEN2 &= ~BIT1;
}

void PWM_INT(void) interrupt 14
{
    if (PWMIE & BIT5) // PWM上升沿，ABC线下降沿
    {
        PWMIE |= BIT5;
    }
}

void FLT_MATCH(void) interrupt 15
{
    CCISR = 0xFF;
}
